// Generated by purs version 0.12.5
"use strict";
var Control_Applicative = require("../Control.Applicative/index.js");
var Control_Bind = require("../Control.Bind/index.js");
var Control_Monad_Free = require("../Control.Monad.Free/index.js");
var Data_Decimal = require("../Data.Decimal/index.js");
var Data_Either = require("../Data.Either/index.js");
var Data_Eq = require("../Data.Eq/index.js");
var Data_Foldable = require("../Data.Foldable/index.js");
var Data_List_Types = require("../Data.List.Types/index.js");
var Data_Map = require("../Data.Map/index.js");
var Data_Map_Internal = require("../Data.Map.Internal/index.js");
var Data_Monoid = require("../Data.Monoid/index.js");
var Data_NonEmpty = require("../Data.NonEmpty/index.js");
var Data_Ord = require("../Data.Ord/index.js");
var Data_Quantity = require("../Data.Quantity/index.js");
var Data_Set = require("../Data.Set/index.js");
var Data_Show = require("../Data.Show/index.js");
var Data_Unit = require("../Data.Unit/index.js");
var Data_Units = require("../Data.Units/index.js");
var Data_Units_Currency = require("../Data.Units.Currency/index.js");
var Data_Units_Imperial = require("../Data.Units.Imperial/index.js");
var Data_Units_SI = require("../Data.Units.SI/index.js");
var Data_Units_SI_Accepted = require("../Data.Units.SI.Accepted/index.js");
var Data_Units_SI_Derived = require("../Data.Units.SI.Derived/index.js");
var Data_Units_Time = require("../Data.Units.Time/index.js");
var Effect_Aff = require("../Effect.Aff/index.js");
var Insect = require("../Insect/index.js");
var Insect_Environment = require("../Insect.Environment/index.js");
var Insect_Format = require("../Insect.Format/index.js");
var Insect_Language = require("../Insect.Language/index.js");
var Insect_Parser = require("../Insect.Parser/index.js");
var Insect_PrettyPrint = require("../Insect.PrettyPrint/index.js");
var Test_Unit = require("../Test.Unit/index.js");
var Test_Unit_Assert = require("../Test.Unit.Assert/index.js");
var Test_Unit_Main = require("../Test.Unit.Main/index.js");
var Text_Parsing_Parser = require("../Text.Parsing.Parser/index.js");
var shouldParseAs = function (expected) {
    return function (input) {
        var v = Insect_Parser.parseInsect(Insect_Environment.initialEnvironment)(input);
        if (v instanceof Data_Either.Left) {
            var v1 = Text_Parsing_Parser.parseErrorPosition(v.value0);
            return Test_Unit.failure("Parse error for input '" + (input + ("': " + (Text_Parsing_Parser.parseErrorMessage(v.value0) + (" at position " + Data_Show.show(Data_Show.showInt)(v1.column))))));
        };
        if (v instanceof Data_Either.Right) {
            return Control_Applicative.unless(Effect_Aff.applicativeAff)(Data_Eq.eq(Insect_Language.eqStatement)(v.value0)(expected))(Test_Unit.failure("Unexpected result:\x0a" + ("Input:    '" + (input + ("'\x0a" + ("Output:   " + (Data_Show.show(Insect_Language.showStatement)(v.value0) + ("\x0a" + ("Expected: " + (Data_Show.show(Insect_Language.showStatement)(expected) + "\x0a"))))))))));
        };
        throw new Error("Failed pattern match at Test.Main (line 37, column 3 - line 52, column 1): " + [ v.constructor.name ]);
    };
};
var shouldFail = function (input) {
    var v = Insect_Parser.parseInsect(Insect_Environment.initialEnvironment)(input);
    if (v instanceof Data_Either.Left) {
        return Control_Applicative.pure(Effect_Aff.applicativeAff)(Data_Unit.unit);
    };
    if (v instanceof Data_Either.Right) {
        return Test_Unit.failure("input is expected to throw a parse error: '" + (input + "'"));
    };
    throw new Error("Failed pattern match at Test.Main (line 57, column 3 - line 61, column 1): " + [ v.constructor.name ]);
};
var prettyPrintCheck = function (input) {
    var v = Insect_Parser.parseInsect(Insect_Environment.initialEnvironment)(input);
    if (v instanceof Data_Either.Left) {
        var v1 = Text_Parsing_Parser.parseErrorPosition(v.value0);
        return Test_Unit.failure("Parse error for input '" + (input + ("': " + (Text_Parsing_Parser.parseErrorMessage(v.value0) + (" at position " + Data_Show.show(Data_Show.showInt)(v1.column))))));
    };
    if (v instanceof Data_Either.Right) {
        if (v.value0 instanceof Insect_Language.Expression) {
            return shouldParseAs(v.value0)(Insect_Format.format(Insect_Format.fmtPlain)(Insect_PrettyPrint.pretty(v.value0.value0)));
        };
        return Test_Unit.failure("Input is not an expression");
    };
    throw new Error("Failed pattern match at Test.Main (line 74, column 3 - line 92, column 1): " + [ v.constructor.name ]);
};
var expectOutput = function (env) {
    return function (expected) {
        return function (inp) {
            var res = Insect.repl(Insect_Format.fmtPlain)(env)(inp);
            return Control_Applicative.unless(Effect_Aff.applicativeAff)(res.msg === expected)(Test_Unit.failure("Unexpected result:\x0a" + ("Input:    '" + (inp + ("'\x0a" + ("Output:   '" + (res.msg + ("'\x0a" + ("Expected: '" + (expected + "'\x0a"))))))))));
        };
    };
};
var allParseAs = function (expected) {
    return Data_Foldable.traverse_(Effect_Aff.applicativeAff)(Data_Foldable.foldableArray)(shouldParseAs(expected));
};
var main = Test_Unit_Main.runTest((function () {
    var scalar = function (n) {
        return new Insect_Language.Scalar(Data_Decimal.fromNumber(n));
    };
    var q = function (s) {
        return function (u) {
            return new Insect_Language.BinOp(Insect_Language.Mul.value, scalar(s), new Insect_Language.Unit(u));
        };
    };
    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.suite("Parser - Numbers")(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Simple numbers")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(scalar(1.0)))([ "1", "1.0", "  1  ", " 1.0000   ", " +1.0   ", "+1" ]))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(scalar(3.5)))([ "3.5", "  3.5  ", "3.50", "+3.50" ]))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("123.."))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("0.."))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail(".0."))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("."))(function () {
                            return shouldFail(".2");
                        });
                    });
                });
            });
        });
    })))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Large numbers")(allParseAs(new Insect_Language.Expression(scalar(1.23456789e15)))([ "1234567890000000", "1234567890000000.0", "+1234567890000000.0" ])))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Negative numbers")(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Negate(scalar(123.45))))("-123.45")))(function () {
                return Test_Unit.test("Exponential notation")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Negate(scalar(1.3e13))))("-1.3e13"))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(scalar(2.7e-3)))("2.7e-3"))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("123e+"))(function () {
                            return shouldFail("123e-");
                        });
                    });
                }));
            });
        });
    })))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.suite("Parser - Units (this may take some time)")(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Simple")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.Unit(Data_Units_SI.meter)))([ "m", "      m ", "meter", "meters", "metre", "metres" ]))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.Unit(Data_Units_Imperial.inch)))([ "in", "      in ", "inch", "inches" ]))(function () {
                return allParseAs(new Insect_Language.Expression(new Insect_Language.Unit(Data_Units_SI_Accepted.degree)))([ "\xb0", "      \xb0 ", "deg", "degree", "degrees" ]);
            });
        })))(function () {
            var unp = function (v) {
                return v.value0;
            };
            return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("All imperial units")(Data_Foldable.for_(Effect_Aff.applicativeAff)(Data_Foldable.foldableArray)(unp(Insect_Parser.imperialUnitDict))(function (v) {
                return allParseAs(new Insect_Language.Expression(new Insect_Language.Unit(v.value0)))(v.value1);
            })))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("All normal units")(Data_Foldable.for_(Effect_Aff.applicativeAff)(Data_Foldable.foldableArray)(unp(Insect_Parser.normalUnitDict))(function (v) {
                    return allParseAs(new Insect_Language.Expression(new Insect_Language.Unit(v.value0)))(v.value1);
                })))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Data_Foldable.for_(Control_Monad_Free.freeApplicative)(Data_Foldable.foldableArray)(unp(Insect_Parser.prefixDict))(function (v) {
                        return Test_Unit.test("Testing all units with prefix: " + Data_Foldable.intercalate(Data_Foldable.foldableArray)(Data_Monoid.monoidString)(", ")(v.value1))(Data_Foldable.for_(Effect_Aff.applicativeAff)(Data_Foldable.foldableArray)(unp(Insect_Parser.normalUnitDict))(function (v1) {
                            var allCombinations = Control_Bind.bind(Control_Bind.bindArray)(v.value1)(function (v2) {
                                return Control_Bind.bind(Control_Bind.bindArray)(v1.value1)(function (v3) {
                                    return Control_Applicative.pure(Control_Applicative.applicativeArray)(v2 + v3);
                                });
                            });
                            return allParseAs(new Insect_Language.Expression(new Insect_Language.Unit(v.value0(v1.value0))))(allCombinations);
                        }));
                    }))(function () {
                        return Test_Unit.test("Special cases")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.Unit(Data_Units_Time.day)))([ "d", " d " ]))(function () {
                            return allParseAs(new Insect_Language.Expression(new Insect_Language.Unit(Data_Units_SI_Accepted.tonne)))([ "t", " t " ]);
                        }));
                    });
                });
            });
        })))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.suite("Parser - Quantities")(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Simple")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(2.3)(Data_Units_SI.meter)))([ "2.3*m", " 2.3 * m ", "2.3m", "  2.3 m ", "2.3meter", "2.3 meter", "2.3meters", "2.3 metre", "2.3metres" ]))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(5.0)(Data_Units_SI.second)))([ "5s", "5second", "5 seconds" ]))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(5.0)(Data_Units_SI.gram)))([ "5g", "5gram", "5 grams" ]))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(10.0)(Data_Units_Time.minute)))([ "10minutes", "10minute", "10min" ]))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(10.0)(Data_Units_Imperial.mile)))([ "10miles", "10mile" ]))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(10.0)(Data_Units_Imperial.inch)))([ "10inches", "10inch", "10in" ]))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(360.0)(Data_Units_SI_Accepted.degree)))([ "360degrees", "360degree", "360deg", "360\xb0", "360.0\xb0" ]))(function () {
                                        return allParseAs(new Insect_Language.Expression(q(1.0)(Data_Units_SI_Derived.radian)))([ "1.0rad", "1.0 radian", "1.0 radians" ]);
                                    });
                                });
                            });
                        });
                    });
                });
            })))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("SI prefixes")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(2.3)(Data_Units.kilo(Data_Units_SI.meter))))([ "2.3km", "  2.3 km ", "  2.3 kmeter ", "  2.3 kmeters ", "  2.3 kmetre ", "  2.3 kmetres " ]))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(2.3)(Data_Units.milli(Data_Units_SI.meter))))([ "2.3mm", "  2.3 mm ", "  2.3 mmeter ", "  2.3 mmeters ", "  2.3 mmetre ", "  2.3 mmetres " ]))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(2.3)(Data_Units.nano(Data_Units_SI.gram))))([ "2.3ng", "  2.3 ng " ]))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(2.3)(Data_Units.kilo(Data_Units_Time.minute))))([ "2.3kmin", "  2.3 kmin " ]))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(q(2.3)(Data_Units.deci(Data_Units_SI.meter))))([ "2.3dm", "  2.3 dm " ]))(function () {
                                    return allParseAs(new Insect_Language.Expression(q(42.3)(Data_Units.tera(Data_Units_SI_Derived.hertz))))([ "42.3THz", "42.3Thertz" ]);
                                });
                            });
                        });
                    });
                })))(function () {
                    return Test_Unit.test("Divisions")(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Div.value, q(2.3)(Data_Units.kilo(Data_Units_SI.meter)), new Insect_Language.Unit(Data_Units_Time.hour))))([ "2.3km/h", "2.30km/h", "2.30km\xf7h", "2.30 kilometer per hour", "2.30 kilometre per hour", "2.30km per h" ]));
                });
            })))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.suite("Parser - Operators")(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Factorial")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.Factorial(scalar(4.0))))([ "4!", "4.0!", "4 !", " 4 ! ", "(4)!" ]))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, new Insect_Language.Factorial(scalar(5.0)), scalar(3.0))))([ "5!^3", "5!\xb3", "(5!)^3" ]))(function () {
                        return allParseAs(new Insect_Language.Expression(new Insect_Language.Negate(new Insect_Language.Factorial(scalar(5.0)))))([ "-5!", "-(5!)" ]);
                    });
                })))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Exponentiation")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(5.0), scalar(3.0))))([ "5^3", " 5 ^ 3 ", " ( 5 ) ^ ( 3 ) ", " ( ( 5 ) ^ ( 3 ) ) ", " ( 5 ^ 3 ) ", "5^(+3)", "+5^3" ]))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(2.0), new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(3.0), new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(4.0), scalar(5.0))))))("2^3^4^5"))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(4.0), scalar(3.0))))([ "4^3", "4 ^ 3", "4**3", "4 ** 3", "4\xb3", "4  \xb3" ]))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, new Insect_Language.Variable("pi"), scalar(2.0))))([ "pi^2", "pi ^ 2", "pi**2", "pi ** 2", "pi\xb2", "(pi)\xb2" ]))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.Negate(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(3.0), scalar(4.0)))))([ "-3^4", "-3 ^ 4", "-3**4", "-3 ** 4", "-(3^4)" ]))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(3.0), new Insect_Language.Negate(scalar(1.4)))))([ "3 ^ (-1.4)", "3 ** (-1.4)" ]))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("\xb3"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("\xb32"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("2^"))(function () {
                                                        return shouldFail("^2");
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            });
                        });
                    })))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Multiplication")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, scalar(5.0), scalar(3.0))))([ "5*3", " 5 * 3 ", " ( 5 ) * ( 3 ) ", " ( 5 ) ( 3 ) ", " ( ( 5 ) * ( 3 ) ) ", " ( 5 * 3 ) ", "5(3)", "(5)3", "5(+3)", "+5*3" ]))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, scalar(5.0), Insect_Language.Negate.create(scalar(3.0)))))([ "5*(-3)", " 5 * (-3) ", " ( 5 ) * ( -3 ) ", " ( ( 5 ) * (-( 3 )) ) ", " ( 5 * (-3) ) ", "+5*(-3)" ]))(function () {
                                return shouldFail("5*");
                            });
                        })))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Division")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Div.value, scalar(5.0), scalar(3.0))))([ "5/3", "5 per 3", " 5 / 3 ", " ( 5 ) / ( 3 ) ", " ( ( 5 ) / ( 3 ) ) ", " ( 5 / 3 ) " ]))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("5/"))(function () {
                                    return shouldFail("5 per");
                                });
                            })))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Modulo")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mod.value, scalar(5.0), scalar(3.0))))([ "5%3", "5 % 3", " ( 5 ) % ( 3 ) ", " ( ( 5 ) % ( 3 ) ) ", " ( 5 % 3 ) " ]))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("5%"))(function () {
                                        return shouldFail("%2");
                                    });
                                })))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Addition")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Add.value, scalar(5.0), scalar(3.0))))([ "5+3", " 5 + 3 ", " ( 5 ) + ( 3 ) ", " ( ( 5 ) + ( 3 ) ) ", " ( 5 + 3 ) " ]))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("3 + "))(function () {
                                            return shouldFail("3 + @");
                                        });
                                    })))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Subtraction")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Sub.value, scalar(5.0), scalar(3.0))))([ "5-3", " 5 - 3 ", " ( 5 ) - ( 3 ) ", " ( ( 5 ) - ( 3 ) ) ", " ( 5 - 3 ) " ]))(function () {
                                            return shouldFail("3 - ");
                                        })))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Unary operators")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Negate(new Insect_Language.Variable("x"))))("-x"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("x")))("+x"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Negate(new Insect_Language.Negate(new Insect_Language.Variable("x")))))("--x"))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Negate(new Insect_Language.Variable("x"))))("++-x"))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, Insect_Language.Negate.create(scalar(1.0)), Insect_Language.Negate.create(scalar(2.0)))))("-1 * -2"))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, scalar(1.0), scalar(2.0))))("+1 * +2"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Sub.value, Insect_Language.Negate.create(scalar(1.0)), Insect_Language.Negate.create(scalar(2.0)))))("-1 - -2"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Sub.value, scalar(1.0), scalar(2.0))))("+1 - +2"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Negate(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(2.0), scalar(3.0)))))("-2^3"))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Negate(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(2.0), scalar(3.0)))))("-2\xb3"))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(2.0), Insect_Language.Negate.create(scalar(3.0)))))("2^-3"))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(2.0), scalar(3.0))))("2^+3"))(function () {
                                                                                            return shouldParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(2.0), new Insect_Language.Negate(new Insect_Language.BinOp(Insect_Language.Pow.value, scalar(3.0), new Insect_Language.Negate(scalar(4.0)))))))("2^-3^-4");
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            })))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Precedence")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Add.value, q(5.0)(Data_Units_SI.meter), new Insect_Language.BinOp(Insect_Language.Mul.value, q(3.0)(Data_Units_Imperial.inch), scalar(7.0)))))([ "5m+3in*7", "5m+(3in*7)", "5m+(3in\xb77)", "5m+(3in\u22c57)", "5m+3in\xd77", "  5 m +   3  in * 7    " ]))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, new Insect_Language.BinOp(Insect_Language.Add.value, q(5.0)(Data_Units_SI.meter), q(3.0)(Data_Units_Imperial.inch)), scalar(7.0))))([ "(5m+3in)*7", "((5m+3in))*7", "(((((((5m))+((3in)))))))*((7))", "  (  5 m + ( 3  in )  )  * 7    " ]))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, new Insect_Language.BinOp(Insect_Language.Div.value, scalar(5.0), scalar(3.0)), scalar(2.0))))([ "5/3*2", "(5/3)*2" ]))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("3+*4"))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("3*/4"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("(3+4"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("3+4)"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("3+("))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("()"))(function () {
                                                                                    return shouldFail("(3+)4");
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                })))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Multiple division")(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Div.value, new Insect_Language.BinOp(Insect_Language.Div.value, scalar(42.0), scalar(7.0)), scalar(3.0))))([ "42/7/3", "(42/7)/3", "42 per 7 per 3" ])))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Multiple division - per precedence")(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Div.value, new Insect_Language.Unit(Data_Units_Currency.euro), new Insect_Language.BinOp(Insect_Language.Div.value, new Insect_Language.Unit(Data_Units_SI.meter), new Insect_Language.Unit(Data_Units_SI.second)))))([ "euro / (meter / second)", "euro / meter per second", "euro per (meter per second)" ])))(function () {
                                                            return Test_Unit.test("Involving units")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, q(3.0)(Data_Units_SI.meter), scalar(2.0))))([ "(3m)^2", "(3.0m)^(2.0)" ]))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, scalar(3.0), new Insect_Language.BinOp(Insect_Language.Pow.value, new Insect_Language.Unit(Data_Units_SI.meter), scalar(2.0)))))([ "3m^2", "3.0(m)^(2.0)", "3m\xb2", "3 m\xb2", "3\xb7m\xb2", "3\u22c5m\xb2", "3\xd7m\xb2", "3\xb7m^(2.0)" ]))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Div.value, q(3.0)(Data_Units_SI.meter), new Insect_Language.Unit(Data_Units_SI.second))))([ "3m/s", "3 meter / second", "3 meter per second", "3 metre / second", "3 metre per second", "(3m)/s" ]))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, scalar(3.0), new Insect_Language.BinOp(Insect_Language.Div.value, new Insect_Language.Unit(Data_Units_SI.meter), new Insect_Language.Unit(Data_Units_SI.second)))))([ "3\xb7m/s", "3*meter / second", "3*meter / sec", "3*metre / second", "3*metre / sec" ]))(function () {
                                                                            return allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Pow.value, new Insect_Language.Unit(Data_Units_SI.meter), Insect_Language.Negate.create(scalar(1.0)))))([ "m^(-1)", "m^(-1.0)", "meter^(-1.0)", "metre^(-1.0)" ]);
                                                                        });
                                                                    });
                                                                });
                                                            }));
                                                        });
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            });
                        });
                    });
                })))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.suite("Parser - Conversions")(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Simple")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.ConvertTo.value, q(2.3)(Data_Units_SI.meter), new Insect_Language.Unit(Data_Units_Imperial.inch))))([ "2.3m -> in", "  2.3 meters->inches ", "  2.3 m  ->  in ", "2.3m\u2192in", "  2.3 m  \u2192  in ", "2.3m to in", "  2.3 m  to  in " ]))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.ConvertTo.value, q(120.0)(Data_Units_Time.minute), new Insect_Language.Unit(Data_Units_Time.hour))))([ "120min -> h", "120minutes -> hours" ]))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("2.3m->"))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("-> km"))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("2.3m \u2192"))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("2.3m to"))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("to km"))(function () {
                                                return shouldFail("to");
                                            });
                                        });
                                    });
                                });
                            });
                        });
                    })))(function () {
                        return Test_Unit.test("Complex units")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.ConvertTo.value, new Insect_Language.BinOp(Insect_Language.Mul.value, scalar(36.0), new Insect_Language.BinOp(Insect_Language.Div.value, new Insect_Language.Unit(Data_Units.kilo(Data_Units_SI.meter)), new Insect_Language.Unit(Data_Units_Time.hour))), new Insect_Language.Unit(Data_Units.divideUnits(Data_Units_Imperial.mile)(Data_Units_Time.hour)))))([ "36\xb7km/h -> mph", " 36 \xb7 km / hour->mph" ]))(function () {
                            return allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.ConvertTo.value, new Insect_Language.BinOp(Insect_Language.Div.value, q(36.0)(Data_Units.kilo(Data_Units_SI.meter)), new Insect_Language.Unit(Data_Units_Time.hour)), new Insect_Language.Unit(Data_Units.divideUnits(Data_Units_Imperial.mile)(Data_Units_Time.hour)))))([ "36km/h -> mph", " 36km / hour->mph " ]);
                        }));
                    })))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.suite("Parser - Identifiers")(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Valid and invalid names")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("x")))("x"))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("\xb5")))("\xb5"))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("pi")))("pi"))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("tau")))("tau"))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("x_2")))("x_2"))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("l\xe4nge")))("l\xe4nge"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("_prefixed")))("_prefixed"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("x'")))("x'"))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("t''")))("t''"))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("to_")))("to_"))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("xs,as"))(function () {
                                                                    return shouldFail("hello`");
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            });
                        })))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Variables which begin like units")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("myVariable")))("myVariable"))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("density")))("density"))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("\xb5g2")))("\xb5g2"))(function () {
                                        return shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable("in2")))("in2");
                                    });
                                });
                            })))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Variables which begin with 'e'")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, scalar(2.0), new Insect_Language.Variable("ex"))))([ "2ex", "2.0ex", "2 ex" ]))(function () {
                                    return allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, scalar(2.0), new Insect_Language.Variable("e"))))([ "2e", "2.0e", "2 e" ]);
                                })))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Variables before parenthesis")(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, new Insect_Language.Variable("pi"), scalar(2.0))))([ "pi(2)", "pi*(2)", "(pi)(2)" ])))(function () {
                                        return Test_Unit.test("Initial environment")(Data_Foldable.for_(Effect_Aff.applicativeAff)(Data_Set.foldableSet)(Data_Map.keys(Insect_Environment.initialEnvironment.values))(function (ident) {
                                            return shouldParseAs(new Insect_Language.Expression(new Insect_Language.Variable(ident)))(ident);
                                        }));
                                    });
                                });
                            });
                        })))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.suite("Parser - Functions")(Test_Unit.test("Simple")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.Apply("sin", new Data_NonEmpty.NonEmpty(q(30.0)(Data_Units_SI_Accepted.degree), Data_List_Types.Nil.value))))([ "sin(30\xb0)", "  sin( 30\xb0 )  ", "  sin( +30\xb0 )  " ]))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.Apply("sqrt", new Data_NonEmpty.NonEmpty(scalar(2.0), Data_List_Types.Nil.value))))([ "sqrt(2)", "  sqrt( 2.0 )  ", "  sqrt( +2.0 )  " ]))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.Apply("exp", new Data_NonEmpty.NonEmpty(new Insect_Language.Negate(scalar(10.0)), Data_List_Types.Nil.value))))([ "exp(-10)", "  exp( -10 )  " ]))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.Apply("exp", new Data_NonEmpty.NonEmpty(scalar(1.0), new Data_List_Types.Cons(scalar(2.0), new Data_List_Types.Cons(scalar(3.0), Data_List_Types.Nil.value))))))([ "exp(1,2,3)", "  exp(  1  ,  2  ,  3   )  " ]))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.Expression(new Insect_Language.BinOp(Insect_Language.Mul.value, new Insect_Language.Apply("exp", new Data_NonEmpty.NonEmpty(scalar(1.0), Data_List_Types.Nil.value)), new Insect_Language.Apply("exp", new Data_NonEmpty.NonEmpty(scalar(1.0), Data_List_Types.Nil.value)))))([ "exp(1)exp(1)", "  exp( 1 )  exp(  1  )  " ]))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("exp(,)"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("exp(1,)"))(function () {
                                                        return shouldFail("exp()");
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            }))))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.suite("Parser - Variable Assignments")(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Simple")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.VariableAssignment("xyz_123", scalar(1.0)))([ "xyz_123 = 1", "xyz_123=1", "  xyz_123  =  1  " ]))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("x\xb2=3"))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("x+y=3"))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("x+2=3"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("3=5"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("x="))(function () {
                                                        return shouldFail("x=3+");
                                                    });
                                                });
                                            });
                                        });
                                    });
                                })))(function () {
                                    return Test_Unit.test("Reserved names")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("m=2"))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("meter=2"))(function () {
                                            return shouldFail("list=4");
                                        });
                                    }));
                                })))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.suite("Parser - Function Assignments")(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Simple")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(allParseAs(new Insect_Language.FunctionAssignment("xyz_123", new Data_NonEmpty.NonEmpty("x", Data_List_Types.Nil.value), scalar(1.0)))([ "xyz_123(x) = 1", "xyz_123(x)=1", "  xyz_123(x)  =  1  " ]))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("f()=2"))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("f(x,)=3"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("f(2)=3"))(function () {
                                                    return shouldFail("f(x)=");
                                                });
                                            });
                                        });
                                    })))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Multiple arguments")(allParseAs(new Insect_Language.FunctionAssignment("f'", new Data_NonEmpty.NonEmpty("x", new Data_List_Types.Cons("y", new Data_List_Types.Cons("z", Data_List_Types.Nil.value))), new Insect_Language.Variable("x")))([ "f'(x,y,z)=x", " f'( x , y , z ) = x " ])))(function () {
                                            return Test_Unit.test("Reserved names")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("m(x)=2"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(shouldFail("meter(x)=2"))(function () {
                                                    return shouldFail("list(x)=4");
                                                });
                                            }));
                                        });
                                    })))(function () {
                                        var pretty$prime = function (str) {
                                            var v = Insect_Parser.parseInsect(Insect_Environment.initialEnvironment)(str);
                                            if (v instanceof Data_Either.Right && v.value0 instanceof Insect_Language.Expression) {
                                                return Insect_Format.format(Insect_Format.fmtPlain)(Insect_PrettyPrint.pretty(v.value0.value0));
                                            };
                                            return "Error";
                                        };
                                        var equalPretty = function (out) {
                                            return function (inp) {
                                                return Test_Unit_Assert.equal(Data_Eq.eqString)(Data_Show.showString)(out)(pretty$prime(inp));
                                            };
                                        };
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.suite("Pretty printer")(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Consistency")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("-2.3e-12387"))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("2.3e-12387"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("18379173"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("2+3"))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("2+3*5"))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("-3^4+2/(4+2*3)"))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("1-2-3-4-(5-6-7)"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("1/2/3/4/(5/6/7)"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("kg"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("2m/s"))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("a+b*c^d-e*f"))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("sin(x)^3"))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("sin(cos(atanh(x)+2))^3"))(function () {
                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("2^3^4^5"))(function () {
                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("(2^3)^(4^5)"))(function () {
                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("sqrt(1.4^2 + 1.5^2) * cos(pi/3)^2"))(function () {
                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("40kg * 9.8m/s^2 * 150cm"))(function () {
                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("4/3 * pi * r\xb3"))(function () {
                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("vol * density -> kg"))(function () {
                                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("atan(30cm / 2m)"))(function () {
                                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("500km/day -> km/h"))(function () {
                                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("1mrad -> \xb0"))(function () {
                                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("52weeks -> days"))(function () {
                                                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("5in + 2ft -> cm"))(function () {
                                                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("6Mbit/s * 1.5h -> GB"))(function () {
                                                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("2d"))(function () {
                                                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("5t"))(function () {
                                                                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("l\xe4nge * x_2 * \xb5 * _prefixed"))(function () {
                                                                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("2m^3"))(function () {
                                                                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("(2m)^3"))(function () {
                                                                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("(2m)^(3kg)"))(function () {
                                                                                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("(2m)^(3kg)^((4in)^(5ft))^(6s)"))(function () {
                                                                                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("-sqrt(-30m^3)"))(function () {
                                                                                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("-3^4"))(function () {
                                                                                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("(-3)^4"))(function () {
                                                                                                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("5!\xb3"))(function () {
                                                                                                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("2^3!"))(function () {
                                                                                                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("-3!"))(function () {
                                                                                                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(prettyPrintCheck("(-3)!"))(function () {
                                                                                                                                                                                                    return prettyPrintCheck("sin(2,3,4)");
                                                                                                                                                                                                });
                                                                                                                                                                                            });
                                                                                                                                                                                        });
                                                                                                                                                                                    });
                                                                                                                                                                                });
                                                                                                                                                                            });
                                                                                                                                                                        });
                                                                                                                                                                    });
                                                                                                                                                                });
                                                                                                                                                            });
                                                                                                                                                        });
                                                                                                                                                    });
                                                                                                                                                });
                                                                                                                                            });
                                                                                                                                        });
                                                                                                                                    });
                                                                                                                                });
                                                                                                                            });
                                                                                                                        });
                                                                                                                    });
                                                                                                                });
                                                                                                            });
                                                                                                        });
                                                                                                    });
                                                                                                });
                                                                                            });
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            });
                                        })))(function () {
                                            return Test_Unit.test("Format")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2 + 3")("2+3"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2 \xd7 3")("2*3"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2^3")("2^3"))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2 km")("2km"))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("sin(30\xb0)")("sin(30\xb0)"))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2 \xd7 3 \xd7 4")("2*3*4"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2 \xd7 3 \xd7 4")("2*(3*4)"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2 + 3 + 4")("2+3+4"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2 + 3 + 4")("2+(3+4)"))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("atan(30 cm / 2 m)")("atan(30cm / 2m)"))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("1 mrad \u279e \xb0")("1mrad -> \xb0"))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2 km + 2 cm \u279e in")("2km+2cm -> in"))(function () {
                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2^3 + 4^5")("2^3 + 4^5"))(function () {
                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2^3 - 4^5")("2^3 - 4^5"))(function () {
                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2^3 \xd7 4^5")("2^3 * 4^5"))(function () {
                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2 \xd7 3 + 4 \xd7 5")("2 * 3 + 4 * 5"))(function () {
                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("2 \xd7 (3 / 4)")("2 * 3 / 4"))(function () {
                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(equalPretty("123.123 \xd7 km^2 / s^2")("123.123 km^2 / s^2"))(function () {
                                                                                                                    return equalPretty("sin(2, 3, 4)")(" sin(  2  ,  3  ,  4   )  ");
                                                                                                                });
                                                                                                            });
                                                                                                        });
                                                                                                    });
                                                                                                });
                                                                                            });
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            }));
                                        })))(function () {
                                            var expectOutput$prime = expectOutput(Insect_Environment.initialEnvironment);
                                            return Test_Unit.suite("Integration tests")(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Simple input")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("3 m")("3m"))(function () {
                                                return expectOutput$prime("3 m")(" 3.0 meter  ");
                                            })))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Square, cube and other exponentation operators")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("18")("3\xb2*2"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("18")("3\xb2 2"))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("18")("3\xb2\xb72"))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("54")("3\xb3*2"))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("54")("3\xb3(2)"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("9")("(1+2)\xb2"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("12.5664")("2\xb2pi"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("12.5664")("2\xb2 pi"))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("12.5664")("2\xb2\xb7pi"))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("500 cm\xb7m")("5m\xb2 to cm\xb7m"))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("32")("2\u2075"))(function () {
                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("-4")("-4\xb9"))(function () {
                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.5")("2\u207b\xb9"))(function () {
                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.25")("2\u207b\xb2"))(function () {
                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.00001")("10\u207b\u2075"))(function () {
                                                                                                            return shouldFail("32\u207b");
                                                                                                        });
                                                                                                    });
                                                                                                });
                                                                                            });
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                })))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Conversions")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("5.08 cm")("2in to cm"))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("500 m\xb7cm")("5m^2 -> m*cm"))(function () {
                                                            return expectOutput$prime("500 cm\xb7m")("5m^2 -> cm*m");
                                                        });
                                                    })))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Implicit multiplication")((function () {
                                                            var myEnv = {
                                                                values: Data_Map_Internal.insert(Data_Ord.ordString)("x")(new Insect_Environment.StoredValue(Insect_Environment.UserDefined.value, Data_Quantity.quantity(5.0)(Data_Units_SI.meter)))(Insect_Environment.initialEnvironment.values),
                                                                functions: Insect_Environment.initialEnvironment.functions
                                                            };
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput(myEnv)("5 m")("x"))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput(myEnv)("10 m")("2x"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput(myEnv)("10 m")("2 x"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput(myEnv)("25 m\xb2")("x x"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput(myEnv)("25 m\xb2")("x\xb2"))(function () {
                                                                                return expectOutput(myEnv)("Unknown identifier: x2")("x2");
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        })()))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Function inverses")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("sin(asin(0.1234))"))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("cos(acos(0.1234))"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("tan(atan(0.1234))"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("sinh(asinh(0.1234))"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("1.1234")("cosh(acosh(1.1234))"))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("tanh(atanh(0.1234))"))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("log(exp(0.1234))"))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("asin(sin(0.1234))"))(function () {
                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("acos(cos(0.1234))"))(function () {
                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("atan(tan(0.1234))"))(function () {
                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("asinh(sinh(0.1234))"))(function () {
                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("1.1234")("acosh(cosh(1.1234))"))(function () {
                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.1234")("atanh(tanh(0.1234))"))(function () {
                                                                                                                return expectOutput$prime("0.1234")("exp(log(0.1234))");
                                                                                                            });
                                                                                                        });
                                                                                                    });
                                                                                                });
                                                                                            });
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            })))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Temperature conversions")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("284.65 K")("fromCelsius(11.5)"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("304.983 K")("fromFahrenheit(89.3)"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("-273.15")("toCelsius(0 K)"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("-405.67")("toFahrenheit(30 K)"))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("100")("toCelsius(fromCelsius(100))"))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("100")("toFahrenheit(fromFahrenheit(100))"))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("123 K")("fromCelsius(toCelsius(123 K))"))(function () {
                                                                                            return expectOutput$prime("123 K")("fromFahrenheit(toFahrenheit(123 K))");
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                })))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Other functions")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("2")("sqrt(4)"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("5")("log10(100000)"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("15")("log(e^15)"))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("15")("ln(e^15)"))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("4")("ceil(3.1)"))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("3")("floor(3.9)"))(function () {
                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("4")("round(3.9)"))(function () {
                                                                                                return expectOutput$prime("3")("round(3.1)");
                                                                                            });
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    })))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Unit simplification")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("36000 Mbit")("5Mbit/s * 2h"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("2500 cm\xb2")("5cm \xb7 5m"))(function () {
                                                                                return expectOutput$prime("0.2 km")("120km/h*6s");
                                                                            });
                                                                        })))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Examples")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("1080")("1920/16*9"))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("4294967296")("2^32"))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.512957")("sqrt(1.4^2 + 1.5^2) * cos(pi/3)^2"))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("2.5 min")("2min + 30s"))(function () {
                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("150 s")("2min + 30s -> sec"))(function () {
                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("904779000000 km\xb3")("4/3 * pi * (6000km)\xb3"))(function () {
                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("588 m\xb2\xb7kg/s\xb2")("40kg * 9.8m/s^2 * 150cm"))(function () {
                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.5")("sin(30\xb0)"))(function () {
                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("26.8224 m/s")("60mph -> m/s"))(function () {
                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("10 km/h")("240km/day -> km/h"))(function () {
                                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.0572958\xb0")("1mrad -> \xb0"))(function () {
                                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("364 d")("52weeks -> days"))(function () {
                                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("73.66 cm")("5in + 2ft -> cm"))(function () {
                                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("8.53077\xb0")("atan(30cm / 2m) -> \xb0"))(function () {
                                                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("4.05 GB")("6Mbit/s * 1.5h -> GB"))(function () {
                                                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("0.75")("3m/4m"))(function () {
                                                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("4")("4/2*2"))(function () {
                                                                                                                                                return expectOutput$prime("0.5 s")("1/2 Hz -> s");
                                                                                                                                            });
                                                                                                                                        });
                                                                                                                                    });
                                                                                                                                });
                                                                                                                            });
                                                                                                                        });
                                                                                                                    });
                                                                                                                });
                                                                                                            });
                                                                                                        });
                                                                                                    });
                                                                                                });
                                                                                            });
                                                                                        });
                                                                                    });
                                                                                });
                                                                            })))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Error messages")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("Parse error at position 4: Expected end of input")("3kg+"))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("Parse error at position 5: 'kg' is reserved for a physical unit")("kg=2"))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("Assignment error: 'pi' cannot be redefined.")("pi=3"))(function () {
                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("Assignment error: 'sin' cannot be redefined.")("sin=3"))(function () {
                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("Assignment error: 'pi' cannot be redefined.")("pi(x)=3"))(function () {
                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("Assignment error: 'sin' cannot be redefined.")("sin(x)=3"))(function () {
                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("Parse error at position 5: reserved word \"help\"")("help=3"))(function () {
                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("Wrong number of arguments:\x0a\x0a    The function 'sin' takes 1 argument (got 3)")("sin(1,2,3)"))(function () {
                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("Unknown identifier: foo")("foo"))(function () {
                                                                                                                    return expectOutput$prime("Numerical error: division by zero or out-of-bounds error")("1/0");
                                                                                                                });
                                                                                                            });
                                                                                                        });
                                                                                                    });
                                                                                                });
                                                                                            });
                                                                                        });
                                                                                    });
                                                                                })))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Earth mass")((function () {
                                                                                        var env2 = (Insect.repl(Insect_Format.fmtPlain)(Insect_Environment.initialEnvironment)("r = 6000km")).newEnv;
                                                                                        var env3 = (Insect.repl(Insect_Format.fmtPlain)(env2)("vol = 4/3 * pi * r^3")).newEnv;
                                                                                        var env4 = (Insect.repl(Insect_Format.fmtPlain)(env3)("density = 5g/cm^3")).newEnv;
                                                                                        return expectOutput(env4)("4.52389e+24 kg")("vol * density -> kg");
                                                                                    })()))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Free.freeBind)(Test_Unit.test("Pendulum")((function () {
                                                                                            var env2 = (Insect.repl(Insect_Format.fmtPlain)(Insect_Environment.initialEnvironment)("len = 20cm")).newEnv;
                                                                                            return expectOutput(env2)("897.294 ms")("2pi*sqrt(len/g0) -> ms");
                                                                                        })()))(function () {
                                                                                            return Test_Unit.test("Unicode")(Control_Bind.discard(Control_Bind.discardUnit)(Effect_Aff.bindAff)(expectOutput$prime("6.62607e-34 J\xb7s")("2\u03c0\xd7\u210f"))(function () {
                                                                                                var env2 = (Insect.repl(Insect_Format.fmtPlain)(Insect_Environment.initialEnvironment)("\u03bb = 2 \xd7 300\xb5m")).newEnv;
                                                                                                return expectOutput(env2)("499.654 GHz")("\u03bd = c/\u03bb \u2192 GHz");
                                                                                            }));
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            }));
                                        });
                                    });
                                });
                            });
                        });
                    });
                });
            });
        });
    });
})());
module.exports = {
    shouldParseAs: shouldParseAs,
    allParseAs: allParseAs,
    shouldFail: shouldFail,
    expectOutput: expectOutput,
    prettyPrintCheck: prettyPrintCheck,
    main: main
};
